' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2017/10/ 
'
' Box Edge Sample Program
' -----------------------------------------------------------------
Public Class Form_BOX_EDGE_SAMPLE

    '摜i[̈
    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()
    'rfI̓NX
    Private m_video As FVIL.Video.CFviVideo = Nothing

    'PGbWoNX(w)
    Private m_boxedge As FVIL.Edge.CFviBoxEdge = New FVIL.Edge.CFviBoxEdge()
    'GDI}`}EXő삷I[o[CNX
    Private m_FigureOverlay As WIL.GDI.FigureOverlay = New WIL.GDI.FigureOverlay()
    '\pI[o[CNX錾
    Private m_overlay As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    '{bNX\pI[o[CNX錾
    Private m_overlay_box As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'GDI`\NX
    Private m_box As FVIL.GDI.CFviGdiRectangle = New FVIL.GDI.CFviGdiRectangle()
    'GDI\NX
    Private m_lines As List(Of FVIL.GDI.CFviGdiLineSegment) = New List(Of FVIL.GDI.CFviGdiLineSegment)()
    'GDI_\NX
    Private m_point1 As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint()
    Private m_point2 As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint()

    'ԌvNX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()

    'init@CݒtH[
    Public formBroseIni As Form_BROWSEINI = New Form_BROWSEINI()

    'init@CitpXj
    Public m_strIniFilePath As String
    'rfIfoCX̃I[v
    Private m_flgVideoOpened As Boolean
    'ԑp
    Dim msec As Double = 0

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'GbWɐR{{bNX
        ComboBoxEdgeDirection.Items.Clear()
        ComboBoxEdgeDirection.Items.Add("Á")
        ComboBoxEdgeDirection.Items.Add("Õ")
        ComboBoxEdgeDirection.Items.Add("")
        ComboBoxEdgeDirection.SelectedIndex = 1

        'oR{{bNX
        ComboBoxScanDirection.Items.Clear()
        ComboBoxScanDirection.Items.Add("E")
        ComboBoxScanDirection.Items.Add("")
        ComboBoxScanDirection.Items.Add("")
        ComboBoxScanDirection.Items.Add("")
        ComboBoxScanDirection.SelectedIndex = 0

        '}EXCxgo^
        m_FigureOverlay.AddMouseEventHandler(CFviImageView1)

        'GDI`̏
        m_box.Pen.Color = Color.Blue
        'AEApx
        m_box.St = New FVIL.Data.CFviPoint(0, 0)
        m_box.Ed = New FVIL.Data.CFviPoint(100, 100)
        m_box.Angle = New FVIL.Data.CFviAngle(0.0)
        m_box.Axis = New FVIL.Data.CFviPoint(0, 0)
        '`\
        m_box.Enable = True

        'ȍ
        m_point1.Pen.Color = Color.Yellow
        m_point1.Style = FVIL.GDI.FigureStyle.Arrow
        m_point1.Size = New System.Drawing.Size(10, 10)
        m_point2.Pen.Color = Color.Yellow
        m_point2.Style = FVIL.GDI.FigureStyle.Arrow
        m_point2.Size = New System.Drawing.Size(10, 10)

        'GDIǉEL
        m_FigureOverlay.Figures.Add(m_box)
        m_FigureOverlay.Active = True
        m_overlay_box.Active = True

        'o\
        fnLinesDisplay()
    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> System.Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageView1.Image = Me.m_image

        'I[o[C̒ǉ
        CFviImageView1.Display.Overlays.Add(m_overlay)
        CFviImageView1.Display.Overlays.Add(m_FigureOverlay)
        CFviImageView1.Display.Overlays.Add(m_overlay_box)

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        '`NA
        m_overlay.Figures.Clear()

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                '摜TCY
                m_video.ChangeImageSize(m_image)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Value = m_video.ExposureTime
                    ComboBoxTrigger.Enabled = True
                    NumericUpDownExposure.Enabled = True
                Else
                    ComboBoxTrigger.Enabled = False
                    NumericUpDownExposure.Enabled = False
                End If
                ButtonGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            ButtonGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If
    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Try
            '`NA
            m_overlay.Figures.Clear()
            ListViewResult.Items.Clear()

            formBroseIni.UseFileFlg = False

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            '摜ݒ
            m_boxedge.SrcImages(0) = m_image
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged, ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged, NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' LoadFile {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͉摜t@C̃[hB
    ''' </remarks>
    Private Sub ButtonLoadImageFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadImageFile.Click
        '`NA
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()

        Form_BROWSEINI.UseFileFlg = True
        '͉摜t@C̃[h
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = "Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        OpenFileDialog1.Filter += "|Png t@C (*.png)|*.png"
        OpenFileDialog1.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        OpenFileDialog1.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        OpenFileDialog1.DefaultExt = "*.bmp"
        If ((OpenFileDialog1.FileNames.Length <= 0) Or (OpenFileDialog1.ShowDialog(Me) = System.Windows.Forms.DialogResult.Cancel)) Then
            Return
        End If

        Try
            FVIL.File.Function.LoadImageFile(OpenFileDialog1.FileName, m_image, FVIL.PixelMode.Unpacking)
            '摜ݒ
            m_boxedge.SrcImages(0) = m_image
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED,
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    ''' <summary>
    ''' PGbWos{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' PGbWoEʕ\
    ''' </remarks>
    Private Sub ButtonDetection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDetection.Click
        '\
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()

        'ĕ`
        CFviImageView1.Refresh()

        'p[^ݒ
        fnBoxEdgePraramSet()
        'PGbWos
        If (fnBoxEdgeExec()) Then
            'ʕ\
            fnResultDisplay()
        End If
    End Sub

    ''' <summary>
    ''' p[^ݒ
    ''' </summary>
    ''' <remarks>
    ''' p[^ݒ֐
    ''' </remarks>
    Private Sub fnBoxEdgePraramSet()
        'p[^ݒ
        m_boxedge.Box = m_box.ToCFviRectangle
        m_boxedge.Around = NumericUpDownAround.Value
        Select Case ComboBoxEdgeDirection.SelectedIndex
            Case 0
                m_boxedge.EdgeDirection = FVIL.Edge.Direction.DarkToBright
            Case 1
                m_boxedge.EdgeDirection = FVIL.Edge.Direction.BrightToDark
            Case 2
                m_boxedge.EdgeDirection = FVIL.Edge.Direction.Both
        End Select
        m_boxedge.Foot = NumericUpDownFoot.Value
        m_boxedge.Len = NumericUpDownLen.Value
        m_boxedge.LineWidth = NumericUpDownLineWidth.Value
        m_boxedge.MaxThreshold = NumericUpDownMaxThreshold.Value
        m_boxedge.Number = NumericUpDownNumber.Value
        Select Case ComboBoxScanDirection.SelectedIndex
            Case 0
                m_boxedge.ScanDirection = FVIL.ScanDirection.Right
            Case 1
                m_boxedge.ScanDirection = FVIL.ScanDirection.Left
            Case 2
                m_boxedge.ScanDirection = FVIL.ScanDirection.Down
            Case 3
                m_boxedge.ScanDirection = FVIL.ScanDirection.Up
        End Select
        m_boxedge.Threshold = NumericUpDownThreshold.Value
    End Sub

    ''' <summary>
    ''' PGbW(w)os
    ''' </summary>
    ''' <remarks>
    ''' PGbW(w)os֐
    ''' </remarks>
    Private Function fnBoxEdgeExec() As Boolean
        Dim Result As Boolean = False

        Try
            'ԑJn
            m_timer.Start()
            'PGbWos
            m_boxedge.Execute()
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            Result = True
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        Return (Result)
    End Function

    ''' <summary>
    ''' ʕ\
    ''' </summary>
    ''' <remarks>
    ''' ʕ\֐
    ''' </remarks>
    Private Sub fnResultDisplay()
        Dim i As Integer

        '`: oʒu
        For i = 0 To (m_boxedge.Result.Count - 1)
            Dim edge As FVIL.Edge.CFviEdgeData = m_boxedge.Result(i)

            '{}[N
            Dim ol_position As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(edge.Position)
            ol_position.Size = New Size(5, 5)
            ol_position.Style = FVIL.GDI.FigureStyle.Cross
            ol_position.Pen.Color = System.Drawing.Color.Red

            'ԍ
            Dim ol_no As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()
            ol_no.Text = i.ToString()
            ol_no.Position = edge.Position
            ol_no.Align = FVIL.GDI.TextAlign.Right Or FVIL.GDI.TextAlign.Bottom
            ol_no.Color = System.Drawing.Color.Red

            'ǉ
            m_overlay.Figures.Add(ol_position)
            m_overlay.Figures.Add(ol_no)

            'Xg\
            Dim listitem() As String = {i.ToString(), edge.Position.X.ToString("0.00"), edge.Position.Y.ToString("0.00"), edge.Value.ToString("0.00")}
            ListViewResult.Items.Add(New ListViewItem(listitem))
        Next

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageView1.Display.Magnification = 1.0
        'XN[o[
        CFviImageView1.ScrollBarH.Value = 0
        CFviImageView1.ScrollBarV.Value = 0
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageView1.FitImageSize()
        'XN[o[
        CFviImageView1.ScrollBarH.Value = 0
        CFviImageView1.ScrollBarV.Value = 0
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageView1.Display.Magnification
        '\{̐ݒ
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageView1.Display.Magnification
        Value = Value - 0.5
        If (Value <= 0) Then
            'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
            Value = 0.1
        End If
        '\{̐ݒ
        CFviImageView1.Display.Magnification = Value
        'XN[o[
        If ((CFviImageView1.Width - (CFviImageView1.Image.HorzSize * Value)) > 0) Then
            CFviImageView1.ScrollBarH.Value = 0
        End If
        If ((CFviImageView1.Height - (CFviImageView1.Image.VertSize * Value)) > 0) Then
            CFviImageView1.ScrollBarV.Value = 0
        End If
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideoOpened = True) Then
            m_video.Close()
            m_flgVideoOpened = False
        End If
    End Sub

    ''' <summary>
    ''' Xg̃NbNɉĕ\ύX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Xg̃ACeւ̃NbNɉăI[oC̕\ύXB
    ''' </remarks>
    Private Sub ListViewResult_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListViewResult.MouseUp
        Dim index As Integer = 0

        'IXĝ݃I[o[C\AXgȊOIꍇSI[o[C\B
        For i As Integer = 0 To (ListViewResult.Items.Count - 1) Step 1
            Dim item As ListViewItem = ListViewResult.Items(i)
            Dim bEnable As Boolean

            'XgI
            If (ListViewResult.SelectedItems.Count > 0) Then
                bEnable = (item.Checked Or item.Selected)       'IACȅꍇTRUEݒ肵AȊOFALSEݒ肷
            Else
                bEnable = True                                  'XgȊOIꍇSTRUEݒ肷
            End If

            'IACe\i\jɂ
            m_overlay.Figures(index).Enable = bEnable
            m_overlay.Figures(index + 1).Enable = bEnable
            index = index + 2
        Next
        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' GbWo臒l̃G[
    ''' </summary>
    ''' <remarks>
    ''' GbWo臒l0͂ꂽۂɒl-1ɕύX
    ''' </remarks>
    Private Sub NumericUpDownThreshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThreshold.ValueChanged
        If (NumericUpDownThreshold.Value = 0) Then
            NumericUpDownThreshold.Value = -1
            'G[
            MessageBox.Show("͈:-1,1`255", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    ''' <summary>
    ''' o\
    ''' </summary>
    ''' <remarks>
    ''' o\֐
    ''' </remarks>
    Private Sub fnLinesDisplay()
        'o\
        m_overlay_box.Figures.Clear()
        m_lines.Clear()

        'o
        Dim width As Double = m_box.Width / (NumericUpDownNumber.Value - 1)
        Dim height As Double = m_box.Height / (NumericUpDownNumber.Value - 1)
        For i As Integer = 0 To (NumericUpDownNumber.Value - 1) Step 1
            Dim ls As FVIL.GDI.CFviGdiLineSegment = New FVIL.GDI.CFviGdiLineSegment
            ls.Pen.Color = Color.Yellow
            Select Case ComboBoxScanDirection.SelectedIndex
                Case 0 To 1
                    '̐
                    ls.St = New FVIL.Data.CFviPoint(m_box.St.X + 1, m_box.St.Y + height * i)
                    ls.Ed = New FVIL.Data.CFviPoint(m_box.Ed.X + 1, m_box.St.Y + height * i)
                Case 2 To 3
                    '̐
                    ls.St = New FVIL.Data.CFviPoint(m_box.St.X + width * i, m_box.St.Y + 1)
                    ls.Ed = New FVIL.Data.CFviPoint(m_box.St.X + width * i, m_box.Ed.Y + 1)
            End Select
            m_lines.Add(ls)
        Next
        'ǉ
        For i As Integer = 0 To (m_lines.Count - 1) Step 1
            m_overlay_box.Figures.Add(m_lines(i))
        Next

        'o\
        Select Case ComboBoxScanDirection.SelectedIndex()
            Case 0
                'E
                m_point1.X = m_box.St.X + ((m_box.Ed.X - m_box.St.X) / 2)
                m_point1.Y = m_box.St.Y
                m_point1.Angle = New FVIL.Data.CFviAngle(0.0)
                m_point2.X = m_box.St.X + ((m_box.Ed.X - m_box.St.X) / 2)
                m_point2.Y = m_box.Ed.Y
                m_point2.Angle = New FVIL.Data.CFviAngle(0.0)
            Case 1
                '
                m_point1.X = m_box.St.X + ((m_box.Ed.X - m_box.St.X) / 2)
                m_point1.Y = m_box.St.Y
                m_point1.Angle = New FVIL.Data.CFviAngle(180.0)
                m_point2.X = m_box.St.X + ((m_box.Ed.X - m_box.St.X) / 2)
                m_point2.Y = m_box.Ed.Y
                m_point2.Angle = New FVIL.Data.CFviAngle(180.0)
            Case 2
                '
                m_point1.X = m_box.St.X
                m_point1.Y = m_box.St.Y + ((m_box.Ed.Y - m_box.St.Y) / 2)
                m_point1.Angle = New FVIL.Data.CFviAngle(90.0)
                m_point2.X = m_box.Ed.X
                m_point2.Y = m_box.St.Y + ((m_box.Ed.Y - m_box.St.Y) / 2)
                m_point2.Angle = New FVIL.Data.CFviAngle(90.0)
            Case 3
                '
                m_point1.X = m_box.St.X
                m_point1.Y = m_box.St.Y + ((m_box.Ed.Y - m_box.St.Y) / 2)
                m_point1.Angle = New FVIL.Data.CFviAngle(270.0)
                m_point2.X = m_box.Ed.X
                m_point2.Y = m_box.St.Y + ((m_box.Ed.Y - m_box.St.Y) / 2)
                m_point2.Angle = New FVIL.Data.CFviAngle(270.0)
        End Select
        m_overlay_box.Figures.Add(m_point1)
        m_overlay_box.Figures.Add(m_point2)



        Dim gdi_str As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' }EXJ[\̏
    ''' </summary>
    ''' <remarks>
    ''' }EXJ[\Ɍoĕ`
    ''' </remarks>
    Private Sub CFviImageView1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles CFviImageView1.MouseMove
        If (m_FigureOverlay.MouseInfo.bGrip = True) Then
            '\
            m_overlay.Figures.Clear()
            ListViewResult.Items.Clear()

            'o\
            fnLinesDisplay()
        End If
    End Sub

    ''' <summary>
    ''' o
    ''' </summary>
    ''' <remarks>
    ''' o̕\
    ''' </remarks>
    Private Sub NumericUpDownNumber_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownNumber.ValueChanged
        '\
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()
        'o\
        fnLinesDisplay()
    End Sub

    ''' <summary>
    ''' o
    ''' </summary>
    ''' <remarks>
    ''' o̕\
    ''' </remarks>
    Private Sub ComboBoxScanDirection_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxScanDirection.SelectionChangeCommitted
        '\
        m_overlay.Figures.Clear()
        ListViewResult.Items.Clear()
        'o\
        fnLinesDisplay()
    End Sub

End Class
